//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: ibc/core/port/v1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service
///
/// Usage: instantiate `Ibc_Core_Port_V1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Ibc_Core_Port_V1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Ibc_Core_Port_V1_QueryClientInterceptorFactoryProtocol? { get }

  func appVersion(
    _ request: Ibc_Core_Port_V1_QueryAppVersionRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Ibc_Core_Port_V1_QueryAppVersionRequest, Ibc_Core_Port_V1_QueryAppVersionResponse>
}

extension Ibc_Core_Port_V1_QueryClientProtocol {
  internal var serviceName: String {
    return "ibc.core.port.v1.Query"
  }

  /// AppVersion queries an IBC Port and determines the appropriate application version to be used
  ///
  /// - Parameters:
  ///   - request: Request to send to AppVersion.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func appVersion(
    _ request: Ibc_Core_Port_V1_QueryAppVersionRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Ibc_Core_Port_V1_QueryAppVersionRequest, Ibc_Core_Port_V1_QueryAppVersionResponse> {
    return self.makeUnaryCall(
      path: "/ibc.core.port.v1.Query/AppVersion",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAppVersionInterceptors() ?? []
    )
  }
}

internal protocol Ibc_Core_Port_V1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'appVersion'.
  func makeAppVersionInterceptors() -> [ClientInterceptor<Ibc_Core_Port_V1_QueryAppVersionRequest, Ibc_Core_Port_V1_QueryAppVersionResponse>]
}

internal final class Ibc_Core_Port_V1_QueryClient: Ibc_Core_Port_V1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Ibc_Core_Port_V1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the ibc.core.port.v1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Ibc_Core_Port_V1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Ibc_Core_Port_V1_QueryProvider: CallHandlerProvider {
  var interceptors: Ibc_Core_Port_V1_QueryServerInterceptorFactoryProtocol? { get }

  /// AppVersion queries an IBC Port and determines the appropriate application version to be used
  func appVersion(request: Ibc_Core_Port_V1_QueryAppVersionRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Ibc_Core_Port_V1_QueryAppVersionResponse>
}

extension Ibc_Core_Port_V1_QueryProvider {
  internal var serviceName: Substring { return "ibc.core.port.v1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "AppVersion":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Ibc_Core_Port_V1_QueryAppVersionRequest>(),
        responseSerializer: ProtobufSerializer<Ibc_Core_Port_V1_QueryAppVersionResponse>(),
        interceptors: self.interceptors?.makeAppVersionInterceptors() ?? [],
        userFunction: self.appVersion(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Ibc_Core_Port_V1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'appVersion'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAppVersionInterceptors() -> [ServerInterceptor<Ibc_Core_Port_V1_QueryAppVersionRequest, Ibc_Core_Port_V1_QueryAppVersionResponse>]
}
